/*
 * Copyright (c) 2009, Takeyuki Nagao
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or
 * without modification, are permitted provided that the
 * following conditions are met:
 * 
 *  * Redistributions of source code must retain the above
 *    copyright notice, this list of conditions and the
 *    following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the
 *    following disclaimer in the documentation and/or other
 *    materials provided with the distribution.
 *    
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
 * CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
 * OF SUCH DAMAGE.
 */

package dvi.v2.cache;
import java.util.Map;
import java.util.logging.Logger;
public class GlueCacheHandler<K, V1, V2>
implements CacheSerializationHandler<K, V1>
{
  private static final Logger LOGGER = Logger.getLogger(GlueCacheHandler.class
      .getName());
  private final Map<K, V2> next;
  private final CacheEntryTransform<K, V1, V2> transform;
  
  public GlueCacheHandler(Map<K, V2> next, CacheEntryTransform<K, V1, V2> transform)
  {
    this.next = next;
    if (transform == null) {
      this.transform = new EmptyCacheEntryTransform<K, V1, V2>();
    } else {
      this.transform = transform;
    }
  }

  public void marshal(K key, V1 v1) {
    LOGGER.finer("marshal: key=" + key + " v1=" + v1);
    if (next == null) return;
    V2 v2 = getTransform().mapForward(key, v1);
    LOGGER.finer("mapped value: key=" + key + " v2=" + v2);
    next.put(key, v2);
  }

  public V1 unmarshal(K key) {
    LOGGER.finer("unmarshal: key=" + key);
    if (next == null) return null;
    V2 v2 = next.get(key);
    LOGGER.finer("unmarshal: key=" + key + "v2=" + v2);
    V1 v1 = getTransform().mapBackward(key, v2);
    LOGGER.finer("unmapped value: key=" + key + "v1=" + v1);
    return v1;
  }

  public Map<K, V2> getNextMap() {
    return next;
  }

  public CacheEntryTransform<K, V1, V2> getTransform() {
    return transform;
  }
}
